using System;
using System.IO;
using NDesk.DBus;
using org.freedesktop.DBus;

using mf.guardian.utils;

namespace testing_mono
{
	class MainClass
	{
		/// <summary>
		/// The entry point of the program, where the program control starts and ends.
		/// </summary>
		/// <param name='args'>
		/// The command-line arguments.
		/// </param>
		public static void Main (string[] args)
		{
			//Please note:
			//All lines below are only for testing without any sanity-checks (try/catch/etc.)

			//Load the a config-file
			String IniFileName = (System.AppDomain.CurrentDomain.FriendlyName + ".config").Replace (".exe", "");

			//Load the dbus settings from config
			string sDBus;
			string sDBusName;

			//Check if the config-file exists
			if (!File.Exists (IniFileName)) {
				sDBus = "system";
				sDBusName = "own.dbus.object";
			}
			else
			{
				//Open the file
				IniFile Ini = new mf.guardian.utils.IniFile (IniFileName);

				//Get the dbus dameon
				Bus DBus;

				sDBus = Ini.getValue("main","DBus", false, "system");
				switch(sDBus)
				{
					case "session": DBus = Bus.Session; break;
					case "system":
					default: DBus = Bus.System; break;
				}

				//Get the name of the object
				sDBusName = Ini.getValue("main","DBusName", false, "own.dbus.object");
			}



			//Console output
			Console.WriteLine("All done");
			for (int i = 0; i < 100; i++) 
			{
				Console.WriteLine (i.ToString () + " wait...");
				System.Threading.Thread.Sleep(100);
			}
		}
	}
}